import 'dart:ffi';
import 'package:ffi/ffi.dart';
import 'mdb.dart';

typedef EnvCreate = IntPtr Function(Pointer<Pointer<MDBenv>>);

typedef SetMaxDBS = IntPtr Function(Pointer<MDBenv>, IntPtr);

typedef EnvOpen = IntPtr Function(
    Pointer<MDBenv>, Pointer<Utf8>, IntPtr, IntPtr);

typedef StrError = Pointer<Utf8> Function(IntPtr);

typedef TxtBegin = IntPtr Function(
    Pointer<MDBenv>, Pointer<MDBtxn>, IntPtr, Pointer<Pointer<MDBtxn>>);

typedef DbiOpen = IntPtr Function(
    Pointer<MDBtxn>, Pointer<Utf8>, IntPtr, Pointer<IntPtr>);

typedef EnvClose = Void Function(Pointer<MDBenv>);

typedef EnvSync = IntPtr Function(Pointer<MDBenv>, IntPtr);

typedef CursorOpen = IntPtr Function(
    Pointer<MDBtxn>, IntPtr, Pointer<Pointer<MDBcursor>>);

typedef CursorGet = IntPtr Function(
    Pointer<MDBcursor>, Pointer<MDBvalue>, Pointer<MDBvalue>, IntPtr);

typedef CursorClose = Void Function(Pointer<MDBcursor>);

typedef TxtCommit = IntPtr Function(Pointer<MDBtxn>);

typedef MdbEnvCreate = int Function(Pointer<Pointer<MDBenv>>);

typedef MdbEnvSetMaxdbs = int Function(Pointer<MDBenv>, int);

typedef MdbStrError = Pointer<Utf8> Function(int);

typedef MdbEnvOpen = int Function(Pointer<MDBenv>, Pointer<Utf8>, int, int);

typedef MdbTxnBegin = int Function(
    Pointer<MDBenv>, Pointer<MDBtxn>, int, Pointer<Pointer<MDBtxn>>);

typedef MdbDbiOpen = int Function(
    Pointer<MDBtxn>, Pointer<Utf8>, int, Pointer<IntPtr>);

typedef MdbPutP = IntPtr Function(
    Pointer<MDBtxn>, IntPtr, Pointer<MDBvalue>, Pointer<MDBvalue>, IntPtr);

typedef MdbGetP = IntPtr Function(
    Pointer<MDBtxn>, IntPtr, Pointer<MDBvalue>, Pointer<MDBvalue>);

typedef MdbGet = int Function(
    Pointer<MDBtxn>, int, Pointer<MDBvalue>, Pointer<MDBvalue>);

typedef MdbPut = int Function(
    Pointer<MDBtxn>, int, Pointer<MDBvalue>, Pointer<MDBvalue>, int);

typedef MdbDel = int Function(
    Pointer<MDBtxn>, int, Pointer<MDBvalue>, Pointer<MDBvalue>);

typedef MdbCursorOpen = int Function(
    Pointer<MDBtxn>, int, Pointer<Pointer<MDBcursor>>);

typedef MdbCursorGet = int Function(
    Pointer<MDBcursor>, Pointer<MDBvalue>, Pointer<MDBvalue>, int);

typedef MdbCursorClose = void Function(Pointer<MDBcursor>);

typedef MdbTxnCommit = int Function(Pointer<MDBtxn>);

typedef MdbEnvSync = int Function(Pointer<MDBenv>, int);

typedef MdbEnvClose = void Function(Pointer<MDBenv>);
